#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#define DIRECTORY "/home/kingkong/disk0/wtb10/public_html/cgi-bin/"
#define DIRECTORY "/u1/vip/wiltb/cgi-bin/"

/* Match date and redirect to URL. */

/* Return next line from sites file.*/
/*
   Skip comments (1st char #) and NULL lines
   returning NULL line indicates end of file
   call after end of file rewinds the file.
*/
char fn[256]; /* space for file name */

void getline( char b[], int n )
  {
  static FILE *sitesFile= NULL;

  if ( sitesFile )
    {
    fgets( b, n , sitesFile );
    if ( !feof( sitesFile ) )
      if ( (b[0] == '#') || (b[0] == '\n') ) /* skip comments and NULL lines */
        getline( b, n );
      else;
    else /* handle end of file */
      {
      fclose( sitesFile );
      sitesFile= NULL;
      b[0]= 0;
      }
    }
  else /* Need to open the file */
    {
    char *qs;
    

    qs= getenv( "QUERY_STRING" );
    strcpy( fn, DIRECTORY );

    if ( qs )  
      strcat( fn, qs );

#if 0
strcpy( fn, "c:\\MSDEV\\Projects\\cgi-src\\sites.txt" ); /* testing */
strcpy( fn, "d:\\msdev\\projects\\redirect\\sites.txt" ); /* testing */
#endif

    if ( sitesFile= fopen( fn, "r") )
      getline( b, n );
    else
      b[0]= 0;
    }
  }

/* Match line for date less than or equal to current date. */
char *match( char *b )
  {
  static char url[256];
  char *c= NULL;
  time_t now, t;
  struct tm urltime= { 0, 0, 0, 0, 0, 0, 0, 0, 0 };
  char s[256];

  sscanf( b, "%d-%d-%d %s", &urltime.tm_year, &urltime.tm_mon, &urltime.tm_mday, s );
  urltime.tm_mon--;  /* adjust month */

  now= time( NULL );
  t= mktime( &urltime ); 

  if ( t != (time_t) -1 )
	  if ( t <= now )
        {
	    strcpy( url, s );
        c= url;
        }

  return c;
  }

/* Search sites file for match. */
void main()
  {
  char *t, *url= NULL;
  char buff[512];
  int n= 0;

  getline( buff, sizeof buff );
  while ( buff[0] != 0 )
    {
	  n++;
    if ( t= match( buff ) )
      url= t;

    getline( buff, sizeof buff );
    }

  if ( url )
    { 
    printf("HTTP/1.0 302 Moved Temporarily\n");
    printf("Location: %s\n", url);
    printf("\n");

/* no header for now
    printf("Content-Type: text/html\n");
    printf("\n");

    printf("<html>");
    printf("<head>");
    printf("<meta http-equiv=REFRESH content=\"0;URL=%s\">", url);
    printf("</head>");
    printf("<body>");
    printf("<a href=http://www.amdahl.com>Go away!</a>");
    printf("</body>");
    printf("</html>");
  no header for now */
    }   
  else
    {
    printf("Content-Type: text/html\n");
    printf("\n");
    printf("<html>");
    printf("<body>");
    printf("Unable to open file: %s. %d", fn, n);
    printf("</body>");
    printf("</html>");
    }
  }
